Attribute VB_Name = "DXModule"
'Dieser Source stammt von http://www.vb-fun.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

'=== DirectDraw-Initialisations-Variablen ===
Dim DX7 As New DirectX7
Dim DD7 As DirectDraw7
Dim SurfaceDesc As DDSURFACEDESC2
Dim PrimarySurface As DirectDrawSurface7
Dim ddPF As DDPIXELFORMAT
Dim BackBuffer As DirectDrawSurface7
Dim bmpBild1 As DirectDrawSurface7
Dim bolKollision As Boolean

Public running As Boolean

Type strcBild
    x           As Single
    y           As Single
    DirX        As Single
    DirY        As Single
    Width       As Single
    Height      As Single
    AniCount    As Double
End Type

Public AnzahlBilder As Integer
Dim BILD() As strcBild

Const BildBreiteHoehe As Single = 52

Const SCREENWIDTH As Single = 800
Const SCREENHEIGHT As Single = 600

Dim PI As Single
Dim Opposite As Single
Dim Adjacent As Single
Dim Hypotenuse As Single

Public Sub DXSchoner()
    Dim Destrect As RECT
    Dim SrcRect As RECT
    Dim i As Single
    Dim hlpZeile As Integer
    
    ReDim BILD(AnzahlBilder)
    
    frmSS.Show
    frmSS.Refresh
    
    Initialization   'DirectDraw Vollbild initialisieren
    BitmapLaden      'Laden der Bitmaps
    SetPI
    
    SetStartPosition
    
    running = True
    
    Do
        
        For i = 1 To AnzahlBilder
            'prfen ob wir aus den Screenbereich laufen
            If BILD(i).x < 5 Then
                BILD(i).DirX = BILD(i).DirX * -1
            End If
            If BILD(i).y < 5 Then
                BILD(i).DirY = BILD(i).DirY * -1
            End If
            If BILD(i).x + 10 > (SCREENWIDTH - BildBreiteHoehe) Then
                BILD(i).DirX = BILD(i).DirX * -1
            End If
            If BILD(i).y + 10 > (SCREENHEIGHT - BildBreiteHoehe) Then
                BILD(i).DirY = BILD(i).DirY * -1
            End If
            'Ausschnitt bewegen
            BILD(i).x = BILD(i).x + BILD(i).DirX
            BILD(i).y = BILD(i).y + BILD(i).DirY
            'Festlegen welchen Bereich vom Bitmap wir kopieren
            'mchten ... in diesem Fall nur einen Teil
            hlpZeile = Int(BILD(i).AniCount) \ 6
            With SrcRect
                .Left = BildBreiteHoehe * (Int(BILD(i).AniCount) - (hlpZeile * 6)): .Right = .Left + BildBreiteHoehe
                .Top = hlpZeile * BildBreiteHoehe: .Bottom = .Top + BildBreiteHoehe
            End With
            'Ausschnitte in den Backbuffer zeichnen
            BackBuffer.BltFast BILD(i).x, BILD(i).y, bmpBild1, SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
            BILD(i).AniCount = BILD(i).AniCount + 0.5
            If Int(BILD(i).AniCount) > 23 Then BILD(i).AniCount = 0
            
            CheckCollision i
            
        Next i
        
'        BackBuffer.SetForeColor vbRed
'        BackBuffer.SetFont Me.Font
'        BackBuffer.DrawText 10, 10, "DirectDraw und Bitmaps-Kollisionsberprfung via Distanzberechnung", False
'        BackBuffer.DrawText 10, 30, "<Esc> beendet das Programm", False
'        BackBuffer.DrawText 10, 50, "FPS: " & Format(FPS, "0.0"), False
'        If bolKollision Then
'            BackBuffer.DrawText 10, 70, "Kollision", False
'        End If
        
        'Inhalt des BackBuffers in den PrimarySurface kopieren
        PrimarySurface.Flip Nothing, DDFLIP_WAIT
        
        'BackBuffer lschen
        'da ansonsten alter Speicherinhalt angezeigt wird
        ClearBuffer vbBlack
        
        DoEvents
    Loop While running
    
    Terminate
    
End Sub

Private Sub CheckCollision(ByVal ID As Integer)
    Dim j As Integer
    Dim hlpAngle As Double
    For j = 1 To AnzahlBilder
        If j <> ID Then
            'Kugeln auf Kollision prfen...
            If GetDistance(BILD(ID).x + 26, BILD(ID).y + 26, BILD(j).x + 26, BILD(j).y + 26) <= 52 Then
                hlpAngle = GetAngle(BILD(ID).x + 26, BILD(ID).y + 26, BILD(j).x + 26, BILD(j).y + 26)
                BILD(ID).DirX = (Sin(DegToRad(hlpAngle)) * -1) * 5
                BILD(ID).DirY = (-Cos(DegToRad(hlpAngle)) * -1) * 5
                hlpAngle = GetAngle(BILD(j).x + 26, BILD(j).y + 26, BILD(ID).x + 26, BILD(ID).y + 26)
                BILD(j).DirX = (Sin(DegToRad(hlpAngle)) * -1) * 5
                BILD(j).DirY = (-Cos(DegToRad(hlpAngle)) * -1) * 5
            End If
        End If
    Next j
End Sub

Private Sub SetStartPosition()
    Dim i As Integer
    Randomize Time
    For i = 1 To AnzahlBilder
        'Festlegen Startposition der Bilder
        BILD(i).x = Int(Rnd * SCREENWIDTH)
        BILD(i).y = Int(Rnd * SCREENHEIGHT)
        If BILD(i).x < 5 Then BILD(i).x = 10
        If BILD(i).y < 5 Then BILD(i).y = 10
        If BILD(i).x + 10 > (SCREENWIDTH - BildBreiteHoehe) Then BILD(i).x = (SCREENWIDTH - BildBreiteHoehe) - 10
        If BILD(i).y + 10 > (SCREENHEIGHT - BildBreiteHoehe) Then BILD(i).y = (SCREENHEIGHT - BildBreiteHoehe) - 10
        If Int(Rnd * 20) > 10 Then
            BILD(i).DirX = 1
        Else
            BILD(i).DirX = 0.5
        End If
        If Int(Rnd * 20) > 10 Then
            BILD(i).DirY = 1
        Else
            BILD(i).DirY = 0.5
        End If
        If Int(Rnd * 20) > 10 Then BILD(i).DirX = BILD(i).DirX * -1
        If Int(Rnd * 20) > 10 Then BILD(i).DirY = BILD(i).DirY * -1
    Next i
End Sub

Private Sub Initialization() 'DirectDraw wird initialisiert
    
    'Holen wir uns den Zugriff auf das DirectDraw-Objekt.
    'Der leere String-Parameter bedeutet,
    'dass der aktive Bildschirmtreiber benutzt werden soll
    Set DD7 = DX7.DirectDrawCreate("")
    'Die Anwendung soll im VollbildModus laufen
    DD7.SetCooperativeLevel frmSS.hwnd, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
    'Auflsung und Farbtiefe deklarieren
    DD7.SetDisplayMode SCREENWIDTH, SCREENHEIGHT, 16, 0, DDSDM_DEFAULT
    'Beschreibung des PrimarySurface mit einem BackBuffer
    With SurfaceDesc
        .lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
        .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
        .lBackBufferCount = 1
    End With
    'PrimarySurface initialisieren auf dem alles abgebildet wird
    Set PrimarySurface = DD7.CreateSurface(SurfaceDesc)
    
    'Fr die Beschreibung des Backbuffers bentigen wir nur
    'den ddsCaps-Bereich
    SurfaceDesc.ddsCaps.lCaps = DDSCAPS_BACKBUFFER
    'BackBuffer initialisieren in dem alles gezeichnet und dann
    'in die PrimarySurface ge'flipt wird
    Set BackBuffer = PrimarySurface.GetAttachedSurface(SurfaceDesc.ddsCaps)
    
    'Pixelformat mit FarbBitMasken aus der PrimarySurface einlesen
    PrimarySurface.GetPixelFormat ddPF

End Sub

Private Sub BitmapLaden()
    Dim ColorKey As DDCOLORKEY
    Dim BmpDesc As DDSURFACEDESC2
        
    BmpDesc.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    BmpDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    
    BmpDesc.lWidth = 312: BmpDesc.lHeight = 208
    
    Set bmpBild1 = DD7.CreateSurfaceFromFile(App.Path & "\VBFun.bmp", BmpDesc)
    
    'setzen der transparenten Farbe ... in diesem Fall Magenta
    ColorKey.high = (ddPF.lRBitMask + ddPF.lBBitMask)
    ColorKey.low = (ddPF.lRBitMask + ddPF.lBBitMask)
    bmpBild1.SetColorKey DDCKEY_SRCBLT, ColorKey

End Sub

Private Sub Terminate()

    Set bmpBild1 = Nothing
    'alte Auflsung wiederherstellen
    DD7.RestoreDisplayMode
    DD7.SetCooperativeLevel frmSS.hwnd, DDSCL_NORMAL
    Set PrimarySurface = Nothing
    Set DD7 = Nothing
    Set DX7 = Nothing

End Sub

Private Sub ClearBuffer(Color As Long)
    Dim Destrect As RECT
    With Destrect
        .Bottom = SCREENHEIGHT
        .Left = 0
        .Right = SCREENWIDTH
        .Top = 0
    End With
    BackBuffer.BltColorFill Destrect, Color
End Sub

Private Function GetTime() As Long
    GetTime = DX7.TickCount
End Function

Private Sub SetPI()
    PI = Atn(1) * 4
End Sub

Private Function GetDistance(ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Integer
    On Error GoTo ErrEnd
    Opposite = Abs(X2 - X1)
    Adjacent = Abs(Y1 - Y2)
    Hypotenuse = Sqr(Opposite * Opposite + Adjacent * Adjacent)
    GetDistance = Hypotenuse
    Exit Function
ErrEnd:
    GetDistance = 0
End Function

Private Function DegToRad(Degrees As Double) As Double
    DegToRad = Degrees / 180 * PI
End Function

Private Function RadToDeg(Radians As Double) As Double
    RadToDeg = Radians * 180 / PI
End Function

Private Function GetAngle(ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Double
    On Error GoTo ErrEnd
    If Y2 = Y1 Then
        If (X2 - X1) < 0 Then GetAngle = 3 * PI / 2
        If (X2 - X1) > 0 Then GetAngle = PI / 2
    Else
        If (Y2 - Y1) > 0 Then GetAngle = Atn((X2 - X1) / (Y2 - Y1))
        If (Y2 - Y1) < 0 Then GetAngle = Atn((X2 - X1) / (Y2 - Y1)) + PI
    End If
    GetAngle = 180 - RadToDeg(GetAngle)
    If GetAngle < 0 Then GetAngle = GetAngle + 360
    Exit Function
ErrEnd:
    GetAngle = 0
End Function

