Attribute VB_Name = "MainModule"
'Dieser Source stammt von http://www.vb-fun.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

Global Const KEYDOWNEXIT = -1
Global FIRSTTIME As Boolean
Global LASTX As Long
Global LASTY As Long
Global XPOS As Long
Global YPOS As Long
Global Preview As Boolean
Global WPPic As StdPicture
'Maus-Pointer
Type PointAPI
    x As Long
    y As Long
End Type
Public MousePoint As PointAPI

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

'Konstanten fr die Schoner-Vorschau
Private Const WS_CHILD = &H40000000
Private Const GWL_STYLE = (-16)
Private Const GWL_HWNDPARENT = (-8)
Private Const HWND_TOP = 0&
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40

'Wichtige Funktionen aus der API !!!
Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Declare Function GetCursorPos Lib "user32" (lpPoint As PointAPI) As Long
Declare Function GetClientRect Lib "user32" _
    (ByVal hwnd As Long, lpRect As RECT) As Long

Declare Function GetWindowLong Lib "user32" _
    Alias "GetWindowLongA" (ByVal hwnd As Long, _
    ByVal nIndex As Long) As Long

Declare Function SetWindowPos Lib "user32" ( _
    ByVal hwnd As Long, ByVal hWndInsertAfter As Long, _
    ByVal x As Long, ByVal y As Long, ByVal cx As Long, _
    ByVal cy As Long, ByVal wFlags As Long) As Long
    
Declare Function SetWindowLong Lib "user32" _
    Alias "SetWindowLongA" (ByVal hwnd As Long, _
    ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Declare Function SetParent Lib "user32" _
    (ByVal hWndChild As Long, _
    ByVal hWndNewParent As Long) As Long

'Hauptroutine
Sub Main()
    LoadSettingFile
    'Klickt man in der Systemsteuerung/Anzeige beim Bilschirmschoner
    'auf Einstellungen, dann startet Windows den Schoner mit dem
    'Befehlsargument /C
    'anstatt dem eigentlichen Schoner wird dann das Optionen-Fenster
    'angezeigt.
    If Left(UCase(Command), 2) = "/C" Or Left(UCase(Command), 2) = "-C" Then
        frmOptionen.txt_Anzahl.Text = AnzahlBilder
        frmOptionen.Show vbModal
        SaveSettingFile
        Unload frmOptionen
        End
    End If
    'der Bildschirmschoner darf nur einmal laufen, keine weitere Instanz erlaubt
    If App.PrevInstance Then End
    'in der Systemsteuerung/Anzeige unter Bildschirmschoner gibt es eine
    'Vorschau. Windows startet da den Schoner mit dem Befehlsargument /P.
    'Hierbei sollte die Ausgabe des Schoners auf das Vorschau-Rechteck
    'umgeleitet werden.
    'Das geht relativ einfach, denn Windows schickt den Handle vom
    'Vorschaurechteck als Befehlsargument mit.
    If Left(UCase(Command), 2) = "/P" Or Left(UCase(Command), 2) = "-P" Then
        Preview = True
        DoPreviewMode frmSS
        Set frmSS.Picture = LoadResPicture(101, vbResBitmap)
        Exit Sub
    End If
    'Windows schickt kein Befehlsargument mit wenn der eigentliche
    'Bildschirmschoner dargestellt werden soll.
    HIDECURSOR
    DXSchoner
End Sub

'Mauszeiger ausschalten und alte Position sichern
Sub HIDECURSOR()
    Call GetCursorPos(MousePoint)
    XPOS = MousePoint.x
    YPOS = MousePoint.y
    Call ShowCursor(False)
    LASTX = XPOS
    LASTY = YPOS
End Sub

'Tastatur- und Maus-Ereignisse auswerten
Sub MONITOREVENTS(x As Single, y As Single)
    If x = LASTX And y = LASTY Then
        Exit Sub
    Else
        LASTX = x
        LASTY = y
    End If
    If (Not FIRSTTIME) Or LASTX = KEYDOWNEXIT Then
        running = False
        Call ShowCursor(True)
        Set WPPic = Nothing
        Unload frmSS
        End
    Else
        FIRSTTIME = False
    End If
End Sub

'Bildschirmschoner-Vorschau
Sub DoPreviewMode(PreviewForm As Form)
    Dim lngStyle As Long, dispHWND As Long, DispRec As RECT
    
    'der Handle vom Vorschau-Rechteck wird als Befehlsargument mitgeschickt
    dispHWND = CLng(Right(Command, Len(Command) - 3))
    
    'Bildschirmschoner-Fenster laden
    Load PreviewForm

    'und dem Vorschau-Rechteck als "child" zuweisen
    GetClientRect dispHWND, DispRec
    lngStyle = GetWindowLong(PreviewForm.hwnd, GWL_STYLE)
    lngStyle = lngStyle Or WS_CHILD 'Append "WS_CHILD"
    SetWindowLong PreviewForm.hwnd, GWL_STYLE, lngStyle
    SetParent PreviewForm.hwnd, dispHWND
    SetWindowLong PreviewForm.hwnd, GWL_HWNDPARENT, dispHWND
    SetWindowPos PreviewForm.hwnd, HWND_TOP, 0&, 0&, _
        DispRec.Right, DispRec.Bottom, _
        SWP_NOZORDER Or SWP_NOACTIVATE Or SWP_SHOWWINDOW
End Sub

Private Sub LoadSettingFile()
    Dim intFileNr As Integer
    On Error GoTo ERROUT
    If Dir(App.Path & "\VBFunDXSCR.set") <> "" Then
        intFileNr = FreeFile()
        Open App.Path & "\VBFunDXSCR.set" For Binary Access Read Lock Write As intFileNr
        Get intFileNr, 1, AnzahlBilder
        Close intFileNr
    Else
        AnzahlBilder = 3
    End If
    Exit Sub
ERROUT:
    frmOptionen.txt_Anzahl.Text = 3
    AnzahlBilder = 3
End Sub

Private Sub SaveSettingFile()
    Dim intFileNr As Integer
    On Error GoTo ERROUT
    intFileNr = FreeFile()
    Open App.Path & "\VBFunDXSCR.set" For Binary Access Write Lock Read As intFileNr
    Put intFileNr, 1, AnzahlBilder
    Close intFileNr
    Exit Sub
ERROUT:
    frmOptionen.txt_Anzahl.Text = 3
End Sub
